<template>
  <v-sheet class="pa-3 mx-3 mb-5" outlined>
    <v-subheader class="font-weight-bold">
      {{ $t('WhatToDo') }}
    </v-subheader>
    <v-sheet>
      <v-btn
        v-for="(tag , index) in tags" :key="`new_task_form_tag_${index}`" class="ma-md-2 ma-1"
        :small="$vuetify.breakpoint.mobile"
        :color="tag.color" :outlined="index !== tagIndex" @click="setTag(index)">{{ $t(tag.title) }}
      </v-btn>
    </v-sheet>
    <v-form
      ref="form"
      v-model="valid"
      lazy-validation
    >
      <v-text-field
        v-model="notes"
        :counter="20"
        :rules="notesRules"
        :label="$t('Notes')"
        required
      ></v-text-field>
      <v-text-field
        v-model="description"
        :counter="50"
        :label="$t('Description')"
        required
      ></v-text-field>
      <v-dialog
        ref="dialogTime"
        v-model="timeModal"
        :return-value.sync="time"
        persistent
        width="290px"
      >
        <template #activator="{ on, attrs }">
          <v-text-field
            v-model="time"
            :label="$t('Select time')"
            prepend-icon="mdi-clock-time-four-outline"
            readonly
            v-bind="attrs"
            v-on="on"
          ></v-text-field>
        </template>
        <v-time-picker
          v-if="timeModal"
          v-model="time"
          ampm-in-title
          format="ampm"
        >
          <v-spacer></v-spacer>
          <v-btn
            text
            color="primary"
            @click="timeModal = false"
          >
            {{ $t('Cancel') }}
          </v-btn>
          <v-btn
            text
            color="primary"
            @click="$refs.dialogTime.save(time)"
          >
            {{ $t('Ok') }}
          </v-btn>
        </v-time-picker>
      </v-dialog>
      <v-switch
        v-model="alarmSet"
        :label="$t('Set the alarm?')"
      ></v-switch>
      <v-dialog
        ref="dialogAlarm"
        v-model="alarmModal"
        :return-value.sync="alarm"
        persistent
        width="290px"
      >
        <template #activator="{ on, attrs }">
          <v-text-field
            v-model="alarm"
            :disabled="!alarmSet"
            :label="$t('Select alarm')"
            :rules="alarmRules"
            prepend-icon="mdi-clock-time-four-outline"
            readonly
            v-bind="attrs"
            v-on="on"
          ></v-text-field>
        </template>
        <v-time-picker
          v-if="alarmModal"
          v-model="alarm"
          ampm-in-title
          format="ampm"
        >
          <v-spacer></v-spacer>
          <v-btn
            text
            color="primary"
            @click="alarmModal = false"
          >
            {{ $t('Cancel') }}
          </v-btn>
          <v-btn
            text
            color="primary"
            @click="$refs.dialogAlarm.save(alarm)"
          >
            {{ $t('Ok') }}
          </v-btn>
        </v-time-picker>
      </v-dialog>
      <v-btn
        :disabled="!validation"
        color="primary"
        block
        large
        @click="newTask"
      >
        {{ $t('Add your task') }}
      </v-btn>
    </v-form>
  </v-sheet>
</template>

<script>
import dateMixin from "~/mixins/dateMixin";

export default {
  name: "TaNewForm",
  mixins: [dateMixin],
  data() {
    return {
      alarmSet: false,
      alarmModal: false,
      alarm: '',
      alarmRules: this.alarmSet ? [
        v => !!v || this.$t('Note is required'),
      ] : [],
      timeModal: false,
      time: '',
      valid: true,
      description: '',
      notesRules: [
        v => !!v || this.$t('Note is required'),
        v => (v && v.length <= 20) || this.$t('Note must be less than 20 characters'),
      ],
      notes: '',
      tagIndex: -1,
      tags: [
        {
          title: 'ReadBook',
          color: 'light-green accent-3'
        },
        {
          title: 'Design',
          color: 'light-blue darken-2'
        },
        {
          title: 'Learning',
          color: 'purple darken-3'
        },
        {
          title: 'Programming',
          color: 'orange darken-1'
        },
      ]
    }
  },
  computed: {
    validation() {
      return this.valid
    }
  },
  methods: {
    setTag(index) {
      this.tagIndex = index
    },
    newTask() {
      const key = `tasks_${this.dateText}`
      let tasks = this.$storage.getLocalStorage(key)
      if (tasks === null) {
        tasks = []
      }
      tasks.push({
        description: this.description,
        notes: this.notes,
        time: this.time,
        tag: this.tagIndex > -1 && this.tags.length > 0 ? this.tags[this.tagIndex] : {
          title: 'Default',
          color: 'blue-grey lighten-2'
        }
      })
      this.$storage.setLocalStorage(key, tasks)
      // close modal and increase new task count
      this.$emit('close-modal')
      this.$store.dispatch('tasks/setNewTaskCount', 1)
    }
  }
}
</script>
